Subject: bug#36374: ‘guix pull’ should not suggest running ‘guix pull’

From: Ludovic Courtès <[email-masked]>
Date: Tue, 24 Mar 2020 18:18:17 +0100

Ping!  :-)

  https://issues.guix.gnu.org/issue/36374

Now’s a good time to fix this one!

Ludo’.

Ludovic Courtès <[email-masked]> skribis:

> Hello!
>
> Julien Lepiller <[email-masked]> skribis:
>
>> Here is a patch to address this issue on Guix System. It creates new
>> files in /etc/skel: an initial profile (.config/guix/initial) tgat
>> only contains a symlink to /run/current-system/profile/bin/guix and
>> the current profile as a symlink to the initial profile.
>>
>> At first boot, and for new users, guix well be found in the current
>> profile, and stays there after guix pull, so we don't need to use hash
>> guix anymore.
>
> I think this addresses the “hash guix” issue (this will no longer be
> needed with this patch), but it only indirectly solves the “guix pull”
> suggestion issue, right?
>
>> From 89b5fa77af87e1a1537c10e929439a902806cc5c Mon Sep 17 00:00:00 2001
>> From: Julien Lepiller <[email-masked]>
>> Date: Wed, 26 Jun 2019 14:24:55 +0200
>> Subject: [PATCH] gnu: system: Symlink guix inside an initial guix pull
>>  profile.
>>
>> This patch adds an initial guix pull profile to the skeletons files used
>> on Guix System.  This ensures that users don't have to type 'hash guix'
>> after their first guix pull, and prevents 'guix pull' from suggesting to
>> run 'guix pull' after it finished successfuly.
>
> It prevents the suggestion, but only because the symlink appears to be
> new.  If you change the mtime of the symlink, or if you run:
>
>   GUIX_DISTRO_AGE_WARNING=1s guix pull
>
> I think you still get the “guix pull” recommendation.
>
>> * gnu/system/shadow.scm (skeleton-directory): Symlink guix inside an
>> initial guix pull profile.
>
> Perhaps we should add it to ‘default-skeletons’ instead of
> special-casing it here?  WDYT?
>
> Thanks for working on it!
>
> Ludo’.